-- What are you doing here?

timer = 0

function CheckCollision()
    if chartiley < 1 or chartilex < 1 or chartiley > 14 or chartilex > 25 then
        charposx = 289
        charposy = 417
        chartilex = 10
        chartiley = 14
    elseif TileTable[chartiley][chartilex] == 2 then
        charposx = 289
        charposy = 417
        chartilex = 10
        chartiley = 14
    elseif TileTable[chartiley][chartilex] == 3 then
        finished = true
    end
end

function LoadMap()
    TileTable = { -- size is 25x19
        {2,2,2,2,2,2,2,2,1,1,3,2,2,2,2,2,2,2,2,2,2,1,1,2,1},
        {2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {1,2,1,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,1,2,1,2,2,1},
        {1,2,2,1,2,1,1,1,1,2,2,2,2,2,1,2,2,2,2,2,1,2,1,2,2},
        {2,2,1,2,1,2,2,2,2,2,2,2,2,1,2,1,2,1,2,2,2,2,1,2,1},
        {1,1,2,1,2,1,2,2,2,2,2,1,2,1,2,2,2,2,2,2,1,2,2,2,2},
        {2,2,1,2,1,2,1,1,1,1,2,1,2,1,2,2,2,2,1,1,2,2,2,2,2},
        {1,2,2,1,2,1,2,2,2,2,2,1,2,1,2,2,2,2,1,2,1,2,2,2,2},
        {1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2},
        {2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2},
        {2,2,1,2,2,2,2,2,1,1,2,2,1,1,2,2,1,1,1,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,1,2,1,1,2,1,2,2,2,1,2,1,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,2,1,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}
    }
end

function GenerateMap(seed)
    TileTable = {}
    if seed then
        love.math.setRandomSeed(seed)
    end
    seedl,seedh = love.math.getRandomSeed()
    while #TileTable < 20 do
        table.insert(TileTable,{})
    end
    for i,v in pairs(TileTable) do
        while #v < 26 do
            table.insert(v,love.math.random(1,3))
        end
    end
    TileTable[love.math.random(10,19)][love.math.random(16,25)] = 4
    TileTable[1][1] = 1
    return TileTable
end

function Move(key)
    speed = 32
    tilespeed = 1
    if love.keyboard.isDown("space") then
        speed = 64
        tilespeed = 2
    end
    if key == "w" or key == "up" then
        if chartiley == 1 then return end
        charposy = charposy - speed
        chartiley = chartiley - tilespeed
    elseif key == "s" or key == "down" then
        if chartiley == 14 then return end
        charposy = charposy + speed
        chartiley = chartiley + tilespeed
    elseif key == "a" or key == "left" then
        if chartilex == 1 then return end
        charposx = charposx - speed
        chartilex = chartilex - tilespeed
    elseif key == "d" or key == "right" then
        if chartilex == 25 then return end
        charposx = charposx + speed
        chartilex = chartilex + tilespeed
    elseif key == "r" then
        charposx = 289
        charposy = 417
        chartilex = 10
        chartiley = 14
        finished = false
        timer = 0
    end
    CheckCollision()
end

function love.load(arg)
    genseed = tonumber(arg[1])
    TileW, TileH = 32, 32
    charposx = 1
    charposy = 1
    chartilex = 1
    chartiley = 1
    terrain = love.graphics.newImage("terrain.png")
    titlescreen = love.graphics.newImage("awedd2.png")
    tiles = {}
    tiles[1] = love.graphics.newQuad(0,0,32,32,terrain:getDimensions())
    tiles[3] = love.graphics.newQuad(0,32,32,32,terrain:getDimensions())
    tiles[2] = love.graphics.newQuad(32,32,32,32,terrain:getDimensions())

    char = love.graphics.newImage("char.png")
    bgm1 = love.audio.newSource("bgm1.mp3")
    timer = 0

    loaded = false
    finished = false
end

function love.update(dt)
    if loaded == true and finished == false then
        timer = timer + dt
    end
    love.audio.play(bgm1)
end

function love.draw()
    if loaded == false then
        love.graphics.draw(titlescreen,0,0,0)
    end
    if TileTable == nil then return end
    for rowIndex=1, #TileTable do
        local row = TileTable[rowIndex]
        for columnIndex=1, #row do
            local number = row[columnIndex]
            love.graphics.draw(terrain, tiles[number], (columnIndex-1)*TileW, (rowIndex-1)*TileH)
        end
    end
    love.graphics.draw(char,charposx,charposy)
    love.graphics.print({{0,0,0},timer})
end

function love.keypressed(key,scancode,isrepeat)
    if loaded == true then
        Move(key)
    else
        LoadMap()
        CheckCollision()
        loaded = true
    end
end